<template>
  <div id="detail">
    <el-row>
      <el-col :span="24" class="debt">
        <el-col :span="24" class="top">
          <detailTopInfo :topTitle="topTitle" :display="display" @goBack="goBack"></detailTopInfo>
        </el-col>
        <el-col :span="24" class="main">
          <el-col :span="24" class="info">
            <regionForm :ruleForm="ruleForm" :formTitle="formTitle" @submitForm="submitForm" @resetForm="resetForm"></regionForm>
          </el-col>
        </el-col>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import detailTopInfo from '@/layout/custom/detailTopInfo.vue';
import detailTop from '@/layout/common/detailTop.vue';
import regionForm from '@/layout/region/regionForm.vue';
import { createNamespacedHelpers, mapGetters } from 'vuex';
const { mapActions: region } = createNamespacedHelpers('region');
export default {
  name: 'detail',
  props: {},
  components: {
    detailTopInfo, //头部导航
    regionForm, //添加地区
  },
  data: () => ({
    display: 'block',
    topTitle: '地区信息管理',
    formTitle: '地区信息',
    ruleForm: {},
  }),
  created() {
    this.searchInfo();
  },
  computed: {
    id() {
      return this.$route.query.id;
    },
  },
  methods: {
    ...region(['query', 'fetch', 'update', 'create']),
    async searchInfo() {
      if (this.id) {
        const res = await this.fetch(this.id);
        if (`${res.errcode}` === '0') {
          this.$set(this, `ruleForm`, res.data);
        } else {
          this.$message.error(result.errmsg ? result.errmsg : 'error');
        }
      }
    },
    // 提交
    async submitForm({ data }) {
      let res;
      if (this.id) {
        res = await this.update(data);
        if (res.errcode === 0) {
          this.$message({
            message: '信息修改成功',
            type: 'success',
          });
        }
      } else {
        res = await this.create(data);
        if (res.errcode === 0) {
          this.$message({
            message: '信息创建成功',
            type: 'success',
          });
        }
      }
      if (this.$checkRes(res)) this.resetForm();

      console.log(res.data);
    },
    // 取消
    resetForm() {
      this.$router.push({ path: '/region/index' });
    },
    // 返回
    goBack() {
      this.$router.go(-1);
    },
  },
};
</script>

<style lang="less" scoped>
.top {
  height: 50px;
  margin: 0 0 10px 0;
}
.main {
  min-height: 765px;
  background: #ffffff;
  padding: 20px;
}
</style>
